package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.Builder;
import lombok.Data;

/**
    * 合同及指南管理
    */
@Data
@Builder
public class ContractTemplateManage {
    /**
    * 唯一主键
    */
    private String id;

    /**
    * 产品id
    */
    private String fundId;

    /**
    * 交易规则
    */
    private String tradingRules;

    /**
    * 基金总费用-认/申购费
    */
    private String expenseSubscription;

    /**
    * 认购费用
    */
    private BigDecimal expenseRatio;

    /**
    * 基金总费用-管理费
    */
    private String expenseManage;

    /**
    * 基金管理费用
    */
    private BigDecimal expenseManageRatio;

    /**
    * 基金总费用-业绩报酬
    */
    private String expenseAchievement;

    /**
    * 基金总费用-业绩报酬比例
    */
    private BigDecimal expenseAchievementRatio;

    /**
    * 理财师分成-认/申购费
    */
    private String ifaSubscription;

    /**
    * 理财师分成-认/申购费比例
    */
    private BigDecimal ifaSubscriptionRatio;

    /**
    * 理财师分成-管理费
    */
    private String ifaManage;

    /**
    * 理财师分成-管理费比例
    */
    private BigDecimal ifaManageRatio;

    /**
    * 理财师分成-业绩报酬
    */
    private String ifaAchievement;

    /**
    * 理财师分成-业绩报酬比例
    */
    private BigDecimal ifaAchievementRatio;

    private Date createTime;

    private String creartBy;

    private Date updateTime;

    private String updateBy;

    /**
    * 删除标志位:0:未删除,1:已删除
    */
    private Integer deleteTag;
}