package com.tanpu.fund.entity.generator;

import com.tanpu.common.id.AutoId;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FundCombineInfo {
    
 public static final String TABLE_NAME = "fund_combine_info";

    /**
     * 
     */
    @AutoId(value = AutoId.IdType.SNOWFLAKE)
    private String id;

    /**
     * 组合基金id
     */
    private String pFundId;

    /**
     * 基金id
     */
    private String fundId;

    /**
     * 最新变动日期
     */
    private Date changeDate;

    /**
     * 占比
     */
    private BigDecimal proportionRatio;

    /**
     * 较上次推荐持仓变动
     */
    private BigDecimal compareLast;

    /**
     * 组合基金标识 0：当前组合 1：历史组合
     */
    private Integer flag;

    /**
     * 
     */
    private Date createTime;

    /**
     * 
     */
    private String createBy;

    /**
     * 
     */
    private Date updateTime;

    /**
     * 
     */
    private String updateBy;

    /**
     * 
     */
    private Integer deleteTag;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", pFundId=").append(pFundId);
        sb.append(", fundId=").append(fundId);
        sb.append(", changeDate=").append(changeDate);
        sb.append(", proportionRatio=").append(proportionRatio);
        sb.append(", compareLast=").append(compareLast);
        sb.append(", flag=").append(flag);
        sb.append(", createTime=").append(createTime);
        sb.append(", createBy=").append(createBy);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", updateBy=").append(updateBy);
        sb.append(", deleteTag=").append(deleteTag);
        sb.append("]");
        return sb.toString();
    }

    /**
     * This enum was generated by MyBatis Generator.
     * This enum corresponds to the database table fund_combine_info
     *
     * @mbg.generated Thu Sep 17 20:59:50 CST 2020
     */
    public enum Column {
        id("id", "id", "VARCHAR", false),
        pFundId("p_fund_id", "pFundId", "VARCHAR", false),
        fundId("fund_id", "fundId", "VARCHAR", false),
        changeDate("change_date", "changeDate", "DATE", false),
        proportionRatio("proportion_ratio", "proportionRatio", "DECIMAL", false),
        compareLast("compare_last", "compareLast", "DECIMAL", false),
        flag("flag", "flag", "INTEGER", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        createBy("create_by", "createBy", "VARCHAR", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        updateBy("update_by", "updateBy", "VARCHAR", false),
        deleteTag("delete_tag", "deleteTag", "INTEGER", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}