package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
/**
    * 产品附件表
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundFileRecord {
    /**
    * 唯一主键
    */
    private String id;

    /**
    * 关联数据ID
    */
    private String refId;

    /**
    * 文件原始名称
    */
    private String fileName;

    /**
    * 文件原链接
    */
    private String originalUrl;

    /**
    * 1:公告,2:附件,3:探普研报
    */
    private Integer type;

    /**
    * 文件后缀名
    */
    private String fileSuffix;

    /**
    * 文件逻辑名
    */
    private String logicalName;

    /**
    * 文件存放路径
    */
    private String logicalPath;

    /**
    * 创建时间
    */
    private Date createTime;

    /**
    * 创建人
    */
    private String createBy;

    /**
    * 修改时间
    */
    private Date updateTime;

    /**
    * 修改人
    */
    private String updateBy;

    /**
    * 删除标识
    */
    private Integer deleteTag;

    /**
    * 状态 0 ：待转换  1：已经转换  2：转换失败
    */
    private Integer status;

    /**
    * 任务id
    */
    private String taskId;
}