package com.tanpu.fund.entity.generator;

import lombok.*;

import java.util.ArrayList;
import java.util.Arrays;

@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class FundInfoWithBLOBs extends FundInfo {
    /**
     * 券商资管产品特点
     */
    private String fundCharacteristic;

    /**
     * 基金投资范围
     */
    private String investmentScope;

    /**
     * 投资限制
     */
    private String investmentRestriction;

    /**
     * 投资理念
     */
    private String fundInvestmentPhilosophy;

    /**
     * 投资策略
     */
    private String fundStrategyDescription;

    /**
     * 组合目标
     */
    private String combineTarget;

    /**
     * 适合群体
     */
    private String fitGroup;

    /**
     * 组合点评
     */
    private String combineComment;

    /**
     * 调仓点评
     */
    private String transferComment;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", fundCharacteristic=").append(fundCharacteristic);
        sb.append(", investmentScope=").append(investmentScope);
        sb.append(", investmentRestriction=").append(investmentRestriction);
        sb.append(", fundInvestmentPhilosophy=").append(fundInvestmentPhilosophy);
        sb.append(", fundStrategyDescription=").append(fundStrategyDescription);
        sb.append(", combineTarget=").append(combineTarget);
        sb.append(", fitGroup=").append(fitGroup);
        sb.append(", combineComment=").append(combineComment);
        sb.append(", transferComment=").append(transferComment);
        sb.append("]");
        return sb.toString();
    }

    /**
     * This enum was generated by MyBatis Generator.
     * This enum corresponds to the database table fund_info
     *
     * @mbg.generated Mon Sep 21 19:58:30 CST 2020
     */
    public enum Column {
        id("id", "id", "VARCHAR", false),
        pFundId("p_fund_id", "pFundId", "VARCHAR", false),
        fundName("fund_name", "fundName", "VARCHAR", false),
        fundShortName("fund_short_name", "fundShortName", "VARCHAR", false),
        fundStructure("fund_structure", "fundStructure", "INTEGER", false),
        fundType("fund_type", "fundType", "INTEGER", false),
        raiseType("raise_type", "raiseType", "INTEGER", false),
        baseCurrency("base_currency", "baseCurrency", "INTEGER", false),
        inceptionDate("inception_date", "inceptionDate", "DATE", false),
        domicile("domicile", "domicile", "INTEGER", false),
        primaryBenchmarkId("primary_benchmark_id", "primaryBenchmarkId", "VARCHAR", false),
        lockupPeriod("lockup_period", "lockupPeriod", "INTEGER", false),
        openDay("open_day", "openDay", "VARCHAR", false),
        duration("duration", "duration", "INTEGER", false),
        advisorId("advisor_id", "advisorId", "VARCHAR", false),
        custodianId("custodian_id", "custodianId", "VARCHAR", false),
        brokerId("broker_id", "brokerId", "VARCHAR", false),
        brokerFutureId("broker_future_id", "brokerFutureId", "VARCHAR", false),
        liquidationAgencyId("liquidation_agency_id", "liquidationAgencyId", "VARCHAR", false),
        trustId("trust_id", "trustId", "VARCHAR", false),
        investmentConsultantId("investment_consultant_id", "investmentConsultantId", "VARCHAR", false),
        administratorId("administrator_id", "administratorId", "VARCHAR", false),
        legalCounselId("legal_counsel_id", "legalCounselId", "VARCHAR", false),
        auditorId("auditor_id", "auditorId", "VARCHAR", false),
        navFrequency("nav_frequency", "navFrequency", "INTEGER", false),
        performanceDisclosureMark("performance_disclosure_mark", "performanceDisclosureMark", "INTEGER", false),
        registerNumber("register_number", "registerNumber", "VARCHAR", false),
        registerDate("register_date", "registerDate", "DATE", false),
        isvisible("isvisible", "isvisible", "INTEGER", false),
        istiered("istiered", "istiered", "INTEGER", false),
        isRanking("is_ranking", "isRanking", "INTEGER", false),
        isRating("is_rating", "isRating", "INTEGER", false),
        specialTips("special_tips", "specialTips", "VARCHAR", false),
        amacUrl("amac_url", "amacUrl", "VARCHAR", false),
        navSourceType("nav_source_type", "navSourceType", "INTEGER", false),
        descInfo("desc_info", "descInfo", "VARCHAR", false),
        strategy("strategy", "strategy", "INTEGER", false),
        substrategy("substrategy", "substrategy", "INTEGER", false),
        riskLevel("risk_level", "riskLevel", "INTEGER", false),
        createBy("create_by", "createBy", "VARCHAR", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        updateBy("update_by", "updateBy", "VARCHAR", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        dataSources("data_sources", "dataSources", "INTEGER", false),
        status("status", "status", "INTEGER", false),
        deleteTag("delete_tag", "deleteTag", "INTEGER", false),
        fundCharacteristic("fund_characteristic", "fundCharacteristic", "LONGVARCHAR", false),
        investmentScope("investment_scope", "investmentScope", "LONGVARCHAR", false),
        investmentRestriction("investment_restriction", "investmentRestriction", "LONGVARCHAR", false),
        fundInvestmentPhilosophy("fund_investment_philosophy", "fundInvestmentPhilosophy", "LONGVARCHAR", false),
        fundStrategyDescription("fund_strategy_description", "fundStrategyDescription", "LONGVARCHAR", false),
        combineTarget("combine_target", "combineTarget", "LONGVARCHAR", false),
        fitGroup("fit_group", "fitGroup", "LONGVARCHAR", false),
        combineComment("combine_comment", "combineComment", "LONGVARCHAR", false),
        transferComment("transfer_comment", "transferComment", "LONGVARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}