package com.tanpu.fund.entity.generator;

import com.tanpu.common.id.AutoId;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

public class FundProfitRate implements Serializable {
    
 public static final String TABLE_NAME = "fund_profit_rate";

    /**
     * 
     */
    @AutoId(value = AutoId.IdType.SNOWFLAKE)
    private String id;

    /**
     * 基金id
     */
    private String fundId;

    /**
     * 年份
     */
    private Integer fpYear;

    /**
     * 月份
     */
    private Integer fpMonth;

    /**
     * 截止日期
     */
    private Date fpDate;

    /**
     * 收益率类型 1:天 2:周 3:月 4:季
     */
    private Integer fpType;

    /**
     * 收益率
     */
    private BigDecimal fpProfitRate;

    /**
     * 
     */
    private Date createTime;

    /**
     * 
     */
    private String createBy;

    /**
     * 
     */
    private Date updateTime;

    /**
     * 
     */
    private String updateBy;

    /**
     * 
     */
    private Integer deleteTag;

    private static final long serialVersionUID = 1L;

    /**
     * 获取
    */
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取基金id
    */
    public String getFundId() {
        return fundId;
    }

    public void setFundId(String fundId) {
        this.fundId = fundId;
    }

    /**
     * 获取年份
    */
    public Integer getFpYear() {
        return fpYear;
    }

    public void setFpYear(Integer fpYear) {
        this.fpYear = fpYear;
    }

    /**
     * 获取月份
    */
    public Integer getFpMonth() {
        return fpMonth;
    }

    public void setFpMonth(Integer fpMonth) {
        this.fpMonth = fpMonth;
    }

    /**
     * 获取截止日期
    */
    public Date getFpDate() {
        return fpDate;
    }

    public void setFpDate(Date fpDate) {
        this.fpDate = fpDate;
    }

    /**
     * 获取收益率类型 1:天 2:周 3:月 4:季
    */
    public Integer getFpType() {
        return fpType;
    }

    public void setFpType(Integer fpType) {
        this.fpType = fpType;
    }

    /**
     * 获取收益率
    */
    public BigDecimal getFpProfitRate() {
        return fpProfitRate;
    }

    public void setFpProfitRate(BigDecimal fpProfitRate) {
        this.fpProfitRate = fpProfitRate;
    }

    /**
     * 获取
    */
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取
    */
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    /**
     * 获取
    */
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    /**
     * 获取
    */
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    /**
     * 获取
    */
    public Integer getDeleteTag() {
        return deleteTag;
    }

    public void setDeleteTag(Integer deleteTag) {
        this.deleteTag = deleteTag;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", fundId=").append(fundId);
        sb.append(", fpYear=").append(fpYear);
        sb.append(", fpMonth=").append(fpMonth);
        sb.append(", fpDate=").append(fpDate);
        sb.append(", fpType=").append(fpType);
        sb.append(", fpProfitRate=").append(fpProfitRate);
        sb.append(", createTime=").append(createTime);
        sb.append(", createBy=").append(createBy);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", updateBy=").append(updateBy);
        sb.append(", deleteTag=").append(deleteTag);
        sb.append("]");
        return sb.toString();
    }

    /**
     * This enum was generated by MyBatis Generator.
     * This enum corresponds to the database table fund_profit_rate
     *
     * @mbg.generated Wed Aug 26 15:32:08 CST 2020
     */
    public enum Column {
        id("id", "id", "VARCHAR", false),
        fundId("fund_id", "fundId", "VARCHAR", false),
        fpYear("fp_year", "fpYear", "INTEGER", false),
        fpMonth("fp_month", "fpMonth", "INTEGER", false),
        fpDate("fp_date", "fpDate", "DATE", false),
        fpType("fp_type", "fpType", "INTEGER", false),
        fpProfitRate("fp_profit_rate", "fpProfitRate", "DECIMAL", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        createBy("create_by", "createBy", "VARCHAR", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        updateBy("update_by", "updateBy", "VARCHAR", false),
        deleteTag("delete_tag", "deleteTag", "INTEGER", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}