package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
/**
    * 产品QA
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundQa {
    private String id;

    /**
    * 问题类型  1：提问 2回答
    */
    private Integer qaType;

    /**
    * 产品ID
    */
    private String fundId;

    /**
    * 问题ID
    */
    private String askId;

    /**
    * 0 :未回答  1已回答
    */
    private Integer status;

    /**
    * 审批状态 0：待审批  1：审批通过  2：未通过
    */
    private Integer verifyStatus;

    /**
    * 用户头像
    */
    private String userHead;

    /**
    * 用户昵称
    */
    private String userNickname;

    /**
    * 1：运营 2：平台用户
    */
    private Integer qaSource;

    /**
    * 排序
    */
    private Integer sort;

    /**
    * 提问/回答人ID
    */
    private String createBy;

    /**
    * 提问/回答时间
    */
    private Date createTime;

    private String updateBy;

    private Date updateTime;

    /**
    * 逻辑删除标志位
    */
    private Integer deleteTag;

    /**
    * 问题/回答内容
    */
    private String content;
}