package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
/**
    * 基金风险调整收益指标
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundRiskadjretStats {
    private String id;

    /**
    * 基金id
    */
    private String fundId;

    /**
    * 截至日期
    */
    private Date endDate;

    /**
    * 最近一年的夏普比率
    */
    private BigDecimal sharperatio1y;

    /**
    * 最近两年的夏普比率
    */
    private BigDecimal sharperatio2y;

    /**
    * 最近三年的夏普比率
    */
    private BigDecimal sharperatio3y;

    /**
    * 最近四年的夏普比率
    */
    private BigDecimal sharperatio4y;

    /**
    * 最近五年的夏普比率
    */
    private BigDecimal sharperatio5y;

    /**
    * 成立以来的夏普比率
    */
    private BigDecimal sharperatioIncep;

    /**
    * 最近一年的索提诺比率
    */
    private BigDecimal sortinoratio1y;

    /**
    * 最近两年的索提诺比率
    */
    private BigDecimal sortinoratio2y;

    /**
    * 最近三年的索提诺比率
    */
    private BigDecimal sortinoratio3y;

    /**
    * 最近四年的索提诺比率
    */
    private BigDecimal sortinoratio4y;

    /**
    * 最近五年的索提诺比率
    */
    private BigDecimal sortinoratio5y;

    /**
    * 成立以来的索提诺比率
    */
    private BigDecimal sortinoratioIncep;

    /**
    * 最近一年的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMar1y;

    /**
    * 最近两年的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMar2y;

    /**
    * 最近三年的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMar3y;

    /**
    * 最近四年的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMar4y;

    /**
    * 最近五年的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMar5y;

    /**
    * 成立以来的索提诺比率(MAR)
    */
    private BigDecimal sortinoratioMarIncep;

    /**
    * 最近一年的特雷诺比率
    */
    private BigDecimal treynorratio1y;

    /**
    * 最近两年的特雷诺比率
    */
    private BigDecimal treynorratio2y;

    /**
    * 最近三年的特雷诺比率
    */
    private BigDecimal treynorratio3y;

    /**
    * 最近四年的特雷诺比率
    */
    private BigDecimal treynorratio4y;

    /**
    * 最近五年的特雷诺比率
    */
    private BigDecimal treynorratio5y;

    /**
    * 成立以来的特雷诺比率
    */
    private BigDecimal treynorratioIncep;

    /**
    * 最近一年的詹森指数
    */
    private BigDecimal jensen1y;

    /**
    * 最近两年的詹森指数
    */
    private BigDecimal jensen2y;

    /**
    * 最近三年的詹森指数
    */
    private BigDecimal jensen3y;

    /**
    * 最近四年的詹森指数
    */
    private BigDecimal jensen4y;

    /**
    * 最近五年的詹森指数
    */
    private BigDecimal jensen5y;

    /**
    * 成立以来的詹森指数
    */
    private BigDecimal jensenIncep;

    /**
    * 最近一年的卡玛比率
    */
    private BigDecimal calmarratio1y;

    /**
    * 最近两年的卡玛比率
    */
    private BigDecimal calmarratio2y;

    /**
    * 最近三年的卡玛比率
    */
    private BigDecimal calmarratio3y;

    /**
    * 最近四年的卡玛比率
    */
    private BigDecimal calmarratio4y;

    /**
    * 最近五年的卡玛比率
    */
    private BigDecimal calmarratio5y;

    /**
    * 成立以来的卡玛比率
    */
    private BigDecimal calmarratioIncep;

    /**
    * 最近一年的欧米茄比率
    */
    private BigDecimal omegaratio1y;

    /**
    * 最近两年的欧米茄比率
    */
    private BigDecimal omegaratio2y;

    /**
    * 最近三年的欧米茄比率
    */
    private BigDecimal omegaratio3y;

    /**
    * 最近四年的欧米茄比率
    */
    private BigDecimal omegaratio4y;

    /**
    * 最近五年的欧米茄比率
    */
    private BigDecimal omegaratio5y;

    /**
    * 成立以来的欧米茄比率
    */
    private BigDecimal omegaratioIncep;

    /**
    * 最近一年的卡帕比率
    */
    private BigDecimal kapparatio1y;

    /**
    * 最近两年的卡帕比率
    */
    private BigDecimal kapparatio2y;

    /**
    * 最近三年的卡帕比率
    */
    private BigDecimal kapparatio3y;

    /**
    * 最近四年的卡帕比率
    */
    private BigDecimal kapparatio4y;

    /**
    * 最近五年的卡帕比率
    */
    private BigDecimal kapparatio5y;

    /**
    * 成立以来的卡帕比率
    */
    private BigDecimal kapparatioIncep;

    private Date updateTime;

    private Date createTime;

    private Integer deleteTag;
}