package com.tanpu.fund.entity.generator;

import java.util.Date;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 * 基金状态
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundStatus {
    /**
     * 基金Id
     */
    private String id;

    /**
     * 基金运行状态：1-募集中、2-开放运行、3-封闭运行、4-提前清算、5-到期清算、6-发行失败、7-更换管理人、-1-其他
     */
    private String fundStatus;

    /**
     * 募集开始时间
     */
    private Date statusStartDate;

    /**
     * 募集结束时间
     */
    private Date statusEndDate;

    /**
     * 清算日期
     */
    private Date liquidateDate;

    private String createBy;

    private Date createTime;

    private String updateBy;

    private Date updateTime;

    private Byte deleteTag;
}