package com.tanpu.fund.entity.generator;

import com.tanpu.common.id.AutoId;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

public class UserFundInfo implements Serializable {
    
 public static final String TABLE_NAME = "user_fund_info";

    /**
     * 唯一主键
     */
    @AutoId(value = AutoId.IdType.SNOWFLAKE)
    private String id;

    /**
     * 用户ID
     */
    private String userId;

    /**
     * 组合基金ID
     */
    private String pFundId;

    /**
     * 基金ID
     */
    private String fundId;

    /**
     * 申购费率
     */
    private BigDecimal buyFeeRatio;

    /**
     * 确认份额
     */
    private BigDecimal confirmShare;

    /**
     * 确认份额日期
     */
    private Date confirmShareDate;

    /**
     * 确认金额
     */
    private BigDecimal confirmAmount;

    /**
     * 确认单位净值
     */
    private String fundNavId;

    /**
     * 
     */
    private BigDecimal fundNav;

    /**
     * 初始权重
     */
    private BigDecimal initWeight;

    /**
     * 成本
     */
    private BigDecimal costAmount;

    /**
     * 市值
     */
    private BigDecimal marketValue;

    /**
     * 盈亏
     */
    private BigDecimal profitLoss;

    /**
     * 配比
     */
    private BigDecimal matchRatio;

    /**
     * 
     */
    private Date createTime;

    /**
     * 
     */
    private String createBy;

    /**
     * 
     */
    private Date updateTime;

    /**
     * 
     */
    private String updateBy;

    /**
     * 
     */
    private Integer deleteTag;

    private static final long serialVersionUID = 1L;

    /**
     * 获取唯一主键
    */
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取用户ID
    */
    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    /**
     * 获取组合基金ID
    */
    public String getpFundId() {
        return pFundId;
    }

    public void setpFundId(String pFundId) {
        this.pFundId = pFundId;
    }

    /**
     * 获取基金ID
    */
    public String getFundId() {
        return fundId;
    }

    public void setFundId(String fundId) {
        this.fundId = fundId;
    }

    /**
     * 获取申购费率
    */
    public BigDecimal getBuyFeeRatio() {
        return buyFeeRatio;
    }

    public void setBuyFeeRatio(BigDecimal buyFeeRatio) {
        this.buyFeeRatio = buyFeeRatio;
    }

    /**
     * 获取确认份额
    */
    public BigDecimal getConfirmShare() {
        return confirmShare;
    }

    public void setConfirmShare(BigDecimal confirmShare) {
        this.confirmShare = confirmShare;
    }

    /**
     * 获取确认份额日期
    */
    public Date getConfirmShareDate() {
        return confirmShareDate;
    }

    public void setConfirmShareDate(Date confirmShareDate) {
        this.confirmShareDate = confirmShareDate;
    }

    /**
     * 获取确认金额
    */
    public BigDecimal getConfirmAmount() {
        return confirmAmount;
    }

    public void setConfirmAmount(BigDecimal confirmAmount) {
        this.confirmAmount = confirmAmount;
    }

    /**
     * 获取确认单位净值
    */
    public String getFundNavId() {
        return fundNavId;
    }

    public void setFundNavId(String fundNavId) {
        this.fundNavId = fundNavId;
    }

    /**
     * 获取
    */
    public BigDecimal getFundNav() {
        return fundNav;
    }

    public void setFundNav(BigDecimal fundNav) {
        this.fundNav = fundNav;
    }

    /**
     * 获取初始权重
    */
    public BigDecimal getInitWeight() {
        return initWeight;
    }

    public void setInitWeight(BigDecimal initWeight) {
        this.initWeight = initWeight;
    }

    /**
     * 获取成本
    */
    public BigDecimal getCostAmount() {
        return costAmount;
    }

    public void setCostAmount(BigDecimal costAmount) {
        this.costAmount = costAmount;
    }

    /**
     * 获取市值
    */
    public BigDecimal getMarketValue() {
        return marketValue;
    }

    public void setMarketValue(BigDecimal marketValue) {
        this.marketValue = marketValue;
    }

    /**
     * 获取盈亏
    */
    public BigDecimal getProfitLoss() {
        return profitLoss;
    }

    public void setProfitLoss(BigDecimal profitLoss) {
        this.profitLoss = profitLoss;
    }

    /**
     * 获取配比
    */
    public BigDecimal getMatchRatio() {
        return matchRatio;
    }

    public void setMatchRatio(BigDecimal matchRatio) {
        this.matchRatio = matchRatio;
    }

    /**
     * 获取
    */
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取
    */
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    /**
     * 获取
    */
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    /**
     * 获取
    */
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    /**
     * 获取
    */
    public Integer getDeleteTag() {
        return deleteTag;
    }

    public void setDeleteTag(Integer deleteTag) {
        this.deleteTag = deleteTag;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", userId=").append(userId);
        sb.append(", pFundId=").append(pFundId);
        sb.append(", fundId=").append(fundId);
        sb.append(", buyFeeRatio=").append(buyFeeRatio);
        sb.append(", confirmShare=").append(confirmShare);
        sb.append(", confirmShareDate=").append(confirmShareDate);
        sb.append(", confirmAmount=").append(confirmAmount);
        sb.append(", fundNavId=").append(fundNavId);
        sb.append(", fundNav=").append(fundNav);
        sb.append(", initWeight=").append(initWeight);
        sb.append(", costAmount=").append(costAmount);
        sb.append(", marketValue=").append(marketValue);
        sb.append(", profitLoss=").append(profitLoss);
        sb.append(", matchRatio=").append(matchRatio);
        sb.append(", createTime=").append(createTime);
        sb.append(", createBy=").append(createBy);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", updateBy=").append(updateBy);
        sb.append(", deleteTag=").append(deleteTag);
        sb.append("]");
        return sb.toString();
    }

    /**
     * This enum was generated by MyBatis Generator.
     * This enum corresponds to the database table user_fund_info
     *
     * @mbg.generated Thu Aug 27 17:46:48 CST 2020
     */
    public enum Column {
        id("id", "id", "VARCHAR", false),
        userId("user_id", "userId", "VARCHAR", false),
        pFundId("p_fund_id", "pFundId", "VARCHAR", false),
        fundId("fund_id", "fundId", "VARCHAR", false),
        buyFeeRatio("buy_fee_ratio", "buyFeeRatio", "DECIMAL", false),
        confirmShare("confirm_share", "confirmShare", "DECIMAL", false),
        confirmShareDate("confirm_share_date", "confirmShareDate", "TIMESTAMP", false),
        confirmAmount("confirm_amount", "confirmAmount", "DECIMAL", false),
        fundNavId("fund_nav_id", "fundNavId", "VARCHAR", false),
        fundNav("fund_nav", "fundNav", "DECIMAL", false),
        initWeight("init_weight", "initWeight", "DECIMAL", false),
        costAmount("cost_amount", "costAmount", "DECIMAL", false),
        marketValue("market_value", "marketValue", "DECIMAL", false),
        profitLoss("profit_loss", "profitLoss", "DECIMAL", false),
        matchRatio("match_ratio", "matchRatio", "DECIMAL", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        createBy("create_by", "createBy", "VARCHAR", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        updateBy("update_by", "updateBy", "VARCHAR", false),
        deleteTag("delete_tag", "deleteTag", "INTEGER", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}